//+------------------------------------------------------------------+
//|                                                    BullnBear.mq4 |
//|                                                           doshur |
//|                                            http://www.doshur.com |
//+------------------------------------------------------------------+
#property copyright "doshur"
#property link      "http://www.doshur.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1

extern color Title = SkyBlue;
extern color Strength_UP = YellowGreen;
extern color Strength_DN = Red;
extern color Seperator = SlateGray;
extern color Text = Khaki;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectsDeleteAll();
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int WindowIndex = WindowFind("BullnBear");

//---- Currency Strength

   DrawLabel("Currency Pair", 44, 22, WindowIndex, "EUR    USD    JPY    GBP    CHF", Title);
   DrawLabel("Seperator_1", 4, 32, WindowIndex, "-------------------------------------------", Seperator);
   DrawLabel("M1", 4, 42, WindowIndex, "M1", Text);
   DrawLabel("M5", 4, 56, WindowIndex, "M5", Text);
   DrawLabel("M15", 4, 70, WindowIndex, "M15", Text);
   DrawLabel("M30", 4, 84, WindowIndex, "M30", Text);
   DrawLabel("H1", 4, 98, WindowIndex, "H1", Text);
   DrawLabel("H4", 4, 112, WindowIndex, "H4", Text);
   DrawLabel("Seperator_2", 4, 122, WindowIndex, "-------------------------------------------", Seperator);

//---- EUR

   double EUR_1 = EUR_Strength(1);
   double EUR_2 = EUR_Strength(5);
   double EUR_3 = EUR_Strength(15);
   double EUR_4 = EUR_Strength(30);
   double EUR_5 = EUR_Strength(60);
   double EUR_6 = EUR_Strength(240);
   double EUR_AVG = ((EUR_1 * 6) + (EUR_2 * 5) + (EUR_3 * 4) + (EUR_4 * 3) + (EUR_5 * 2) + EUR_6) / 21;

   DrawStrength("EUR M1", 44, 42, WindowIndex, EUR_1);
   DrawStrength("EUR M5", 44, 56, WindowIndex, EUR_2);
   DrawStrength("EUR M15", 44, 70, WindowIndex, EUR_3);
   DrawStrength("EUR M30", 44, 84, WindowIndex, EUR_4);
   DrawStrength("EUR H1", 44, 98, WindowIndex, EUR_5);
   DrawStrength("EUR H4", 44, 112, WindowIndex, EUR_6);
   DrawStrength("EUR AVG", 44, 132, WindowIndex, EUR_AVG);

//---- USD

   double USD_1 = USD_Strength(1);
   double USD_2 = USD_Strength(5);
   double USD_3 = USD_Strength(15);
   double USD_4 = USD_Strength(30);
   double USD_5 = USD_Strength(60);
   double USD_6 = USD_Strength(240);
   double USD_AVG = ((USD_1 * 6) + (USD_2 * 5) + (USD_3 * 4) + (USD_4 * 3) + (USD_5 * 2) + USD_6) / 21;

   DrawStrength("USD M1", 83, 42, WindowIndex, USD_1);
   DrawStrength("USD M5", 83, 56, WindowIndex, USD_2);
   DrawStrength("USD M15", 83, 70, WindowIndex, USD_3);
   DrawStrength("USD M30", 83, 84, WindowIndex, USD_4);
   DrawStrength("USD H1", 83, 98, WindowIndex, USD_5);
   DrawStrength("USD H4", 83, 112, WindowIndex, USD_6);
   DrawStrength("USD AVG", 83, 132, WindowIndex, USD_AVG);

//---- JPY

   double JPY_1 = JPY_Strength(1);
   double JPY_2 = JPY_Strength(5);
   double JPY_3 = JPY_Strength(15);
   double JPY_4 = JPY_Strength(30);
   double JPY_5 = JPY_Strength(60);
   double JPY_6 = JPY_Strength(240);
   double JPY_AVG = ((JPY_1 * 6) + (JPY_2 * 5) + (JPY_3 * 4) + (JPY_4 * 3) + (JPY_5 * 2) + JPY_6) / 21;

   DrawStrength("JPY M1", 123, 42, WindowIndex, JPY_1);
   DrawStrength("JPY M5", 123, 56, WindowIndex, JPY_2);
   DrawStrength("JPY M15", 123, 70, WindowIndex, JPY_3);
   DrawStrength("JPY M30", 123, 84, WindowIndex, JPY_4);
   DrawStrength("JPY H1", 123, 98, WindowIndex, JPY_5);
   DrawStrength("JPY H4", 123, 112, WindowIndex, JPY_6);
   DrawStrength("JPY AVG", 123, 132, WindowIndex, JPY_AVG);

//---- GBP

   double GBP_1 = GBP_Strength(1);
   double GBP_2 = GBP_Strength(5);
   double GBP_3 = GBP_Strength(15);
   double GBP_4 = GBP_Strength(30);
   double GBP_5 = GBP_Strength(60);
   double GBP_6 = GBP_Strength(240);
   double GBP_AVG = ((GBP_1 * 6) + (GBP_2 * 5) + (GBP_3 * 4) + (GBP_4 * 3) + (GBP_5 * 2) + GBP_6) / 21;

   DrawStrength("GBP M1", 158, 42, WindowIndex, GBP_1);
   DrawStrength("GBP M5", 158, 56, WindowIndex, GBP_2);
   DrawStrength("GBP M15", 158, 70, WindowIndex, GBP_3);
   DrawStrength("GBP M30", 158, 84, WindowIndex, GBP_4);
   DrawStrength("GBP H1", 158, 98, WindowIndex, GBP_5);
   DrawStrength("GBP H4", 158, 112, WindowIndex, GBP_6);
   DrawStrength("GBP AVG", 158, 132, WindowIndex, GBP_AVG);

//---- CHF

   double CHF_1 = CHF_Strength(1);
   double CHF_2 = CHF_Strength(5);
   double CHF_3 = CHF_Strength(15);
   double CHF_4 = CHF_Strength(30);
   double CHF_5 = CHF_Strength(60);
   double CHF_6 = CHF_Strength(240);
   double CHF_AVG = ((CHF_1 * 6) + (CHF_2 * 5) + (CHF_3 * 4) + (CHF_4 * 3) + (CHF_5 * 2) + CHF_6) / 21;

   DrawStrength("CHF M1", 196, 42, WindowIndex, CHF_1);
   DrawStrength("CHF M5", 196, 56, WindowIndex, CHF_2);
   DrawStrength("CHF M15", 196, 70, WindowIndex, CHF_3);
   DrawStrength("CHF M30", 196, 84, WindowIndex, CHF_4);
   DrawStrength("CHF H1", 196, 98, WindowIndex, CHF_5);
   DrawStrength("CHF H4", 196, 112, WindowIndex, CHF_6);
   DrawStrength("CHF AVG", 196, 132, WindowIndex, CHF_AVG);

//---- MA SR
/*
   DrawLabel("MA SR", 243, 22, WindowIndex, "MA SR", Title);
   DrawLabel("Seperator_3", 243, 32, WindowIndex, "--------", Seperator);
   DrawMASR("MASR M1", 243, 42, WindowIndex, 1);
   DrawMASR("MASR M5", 243, 56, WindowIndex, 5);
   DrawMASR("MASR M15", 243, 70, WindowIndex, 15);
   DrawMASR("MASR M30", 243, 84, WindowIndex, 30);
   DrawMASR("MASR H1", 243, 98, WindowIndex, 60);
   DrawMASR("MASR H4", 243, 112, WindowIndex, 240);
   DrawLabel("Seperator_4", 243, 122, WindowIndex, "--------", Seperator);
*/
//---- Trend

   DrawLabel("Trend", 243, 22, WindowIndex, "Trend", Title);
   DrawLabel("Seperator_5", 243, 32, WindowIndex, "--------", Seperator);
   DrawTrend("Trend M1", 243, 42, WindowIndex, 1);
   DrawTrend("Trend M5", 243, 56, WindowIndex, 5);
   DrawTrend("Trend M15", 243, 70, WindowIndex, 15);
   DrawTrend("Trend M30", 243, 84, WindowIndex, 30);
   DrawTrend("Trend H1", 243, 98, WindowIndex, 60);
   DrawTrend("Trend H4", 243, 112, WindowIndex, 240);
   DrawLabel("Seperator_6", 243, 122, WindowIndex, "--------", Seperator);

//---- Information

   DrawLabel("Infomation", 307, 22, WindowIndex, "Infomation", Title);
   DrawLabel("Seperator_7", 307, 32, WindowIndex, "------------------", Seperator);
   DrawLabel("Spread", 307, 42, WindowIndex, "Spread : " + DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD) / 10, 2), Text);
   DrawLabel("Buy Swap", 307, 70, WindowIndex, "Swap B : " + DoubleToStr(MarketInfo(Symbol(), MODE_SWAPLONG) / 10, 2), Text);
   DrawLabel("Sell Swap", 307, 84, WindowIndex, "Swap S : " + DoubleToStr(MarketInfo(Symbol(), MODE_SWAPSHORT) / 10, 2), Text);
   DrawLabel("Seperator_8", 307, 94, WindowIndex, "------------------", Seperator);

//----

   return(0);
  }
//+------------------------------------------------------------------+
//+ MA Direction                                                     |
//+------------------------------------------------------------------+
int MA_Direction(int TF, string Pair)
{
   double MA_UP = iClose(Pair, TF, 0) - iMA(Pair, TF, 8, 1, 3, PRICE_HIGH, 0);
   double MA_DN = iClose(Pair, TF, 0) - iMA(Pair, TF, 8, 1, 3, PRICE_LOW, 0);

   double Result = MA_UP + MA_DN;

   if(Result > 0) return(1); // UP
   if(Result < 0) return(2); // DW

   return(0);
}
//+------------------------------------------------------------------+
//+ EUR Strength                                                     |
//+------------------------------------------------------------------+
double EUR_Strength(int TF)
{
   double EUR = 0;

   if(MA_Direction(TF, "EURUSD") == 1) EUR += 1;
   if(MA_Direction(TF, "EURGBP") == 1) EUR += 1;
   if(MA_Direction(TF, "EURCHF") == 1) EUR += 1;
   if(MA_Direction(TF, "EURJPY") == 1) EUR += 1;

   EUR = EUR / 4 * 100;

   return(EUR);
}
//+------------------------------------------------------------------+
//+ USD Strength                                                     |
//+------------------------------------------------------------------+
double USD_Strength(int TF)
{
   double USD = 0;

   if(MA_Direction(TF, "EURUSD") == 2) USD += 1;
   if(MA_Direction(TF, "GBPUSD") == 2) USD += 1;
   if(MA_Direction(TF, "USDJPY") == 1) USD += 1;
   if(MA_Direction(TF, "USDCHF") == 1) USD += 1;

   USD = USD / 4 * 100;

   return(USD);
}
//+------------------------------------------------------------------+
//+ JPY Strength                                                     |
//+------------------------------------------------------------------+
double JPY_Strength(int TF)
{
   double JPY = 0;

   if(MA_Direction(TF, "EURJPY") == 2) JPY += 1;
   if(MA_Direction(TF, "CHFJPY") == 2) JPY += 1;
   if(MA_Direction(TF, "USDJPY") == 2) JPY += 1;
   if(MA_Direction(TF, "GBPJPY") == 2) JPY += 1;

   JPY = JPY / 4 * 100;

   return(JPY);
}
//+------------------------------------------------------------------+
//+ GBP Strength                                                     |
//+------------------------------------------------------------------+
double GBP_Strength(int TF)
{
   double GBP = 0;

   if(MA_Direction(TF, "EURGBP") == 2) GBP += 1;
   if(MA_Direction(TF, "GBPJPY") == 1) GBP += 1;
   if(MA_Direction(TF, "GBPCHF") == 1) GBP += 1;
   if(MA_Direction(TF, "GBPUSD") == 1) GBP += 1;

   GBP = GBP / 4 * 100;

   return(GBP);
}
//+------------------------------------------------------------------+
//+ CHF Strength                                                     |
//+------------------------------------------------------------------+
double CHF_Strength(int TF)
{
   double CHF = 0;

   if(MA_Direction(TF, "USDCHF") == 2) CHF += 1;
   if(MA_Direction(TF, "CHFJPY") == 1) CHF += 1;
   if(MA_Direction(TF, "GBPCHF") == 2) CHF += 1;
   if(MA_Direction(TF, "EURCHF") == 2) CHF += 1;

   CHF = CHF / 4 * 100;

   return(CHF);
}
//+------------------------------------------------------------------+
//+ Drawings                                                         |
//+------------------------------------------------------------------+
void DrawLabel(string name, int x, int y, int WI, string text, color clr)
{
   ObjectCreate(name, OBJ_LABEL, WI, 0, 0, 0, 0);

   ObjectSet(name, OBJPROP_XDISTANCE, x);
   ObjectSet(name, OBJPROP_YDISTANCE, y);

   ObjectSetText(name, text, 10, "Tahoma", clr);
}
//+------------------------------------------------------------------+
//+ Drawings (Strength)                                              |
//+------------------------------------------------------------------+
void DrawStrength(string name, int x, int y, int WI, double text)
{
   ObjectCreate(name, OBJ_LABEL, WI, 0, 0, 0, 0);

   ObjectSet(name, OBJPROP_XDISTANCE, x);
   ObjectSet(name, OBJPROP_YDISTANCE, y);

   if(text >=50)
      ObjectSetText(name, DoubleToStr(text, 0), 10, "Tahoma", Strength_UP);
   else
      ObjectSetText(name, DoubleToStr(text, 0), 10, "Tahoma", Strength_DN);
}
//+------------------------------------------------------------------+
//+ Drawings (MA SR)                                                 |
//+------------------------------------------------------------------+
void DrawMASR(string name, int x, int y, int WI, int TF)
{
   double MASR = (Close[0] - iMA(NULL, TF, 13, 0, MODE_SMMA, PRICE_CLOSE, 0)) / Point;

   ObjectCreate(name, OBJ_LABEL, WI, 0, 0, 0, 0);

   ObjectSet(name, OBJPROP_XDISTANCE, x);
   ObjectSet(name, OBJPROP_YDISTANCE, y);

   if(MASR > 0)
      ObjectSetText(name, DoubleToStr(MASR, 1), 10, "Tahoma", Strength_UP);
   else
      ObjectSetText(name, DoubleToStr(MASR, 1), 10, "Tahoma", Strength_DN);
}
//+------------------------------------------------------------------+
//+ Drawings (Trend)                                                 |
//+------------------------------------------------------------------+
void DrawTrend(string name, int x, int y, int WI, int TF)
{
   int Dir = MA_Direction(TF, Symbol());

   ObjectCreate(name, OBJ_LABEL, WI, 0, 0, 0, 0);

   ObjectSet(name, OBJPROP_XDISTANCE, x);
   ObjectSet(name, OBJPROP_YDISTANCE, y);

   if(Dir == 1)
      ObjectSetText(name, "UP", 10, "Tahoma", Strength_UP);
   else
      ObjectSetText(name, "DOWN", 10, "Tahoma", Strength_DN);
}